/*
 * mesopotamia @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package org.mesopotamia;

/**
 * Represent language e.g. Java 1.3
 * @author Pavel Vlasov
 * @revision $Revision: 1.2 $
 */
public class Language {
	protected org.mesopotamia.sql.Language dbData;

	
	public Language(String name, String version, String description) {
		dbData=new org.mesopotamia.sql.LanguageImpl();
		dbData.setName(name);
		dbData.setVersion(version);
		dbData.setDescription(description);
	}
	
	/**
	 * Constructed by repository
	 * @param data
	 */
	protected Language(org.mesopotamia.sql.Language data) {
		super();
		dbData = data;
	}

	public String getDescription() {
		return dbData.getDescription();
	}

	public String getName() {
		return dbData.getName();
	}

	public String getVersion() {
		return dbData.getVersion();
	}
	
	public int hashCode() {
		return dbData.getName().hashCode() ^ dbData.getVersion().hashCode();
	}
	
	public boolean equals(Object obj) {
		if (obj==this) {
			return true;
		}
		
		if (obj instanceof Language) {
			return ((Language) obj).getName().equals(getName()) && ((Language) obj).getVersion().equals(getVersion()); 
		}
		
		return false;
	}
}
