/*
 * mesopotamia @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package org.mesopotamia;

import java.sql.SQLException;

public class LoaderBase {

	protected RepositoryLanguage repoLanguage;
	
	/**
	 * Scan dependent loaders must set scan number in LOAD_LEVEL table 
	 */
	protected boolean isScanDependent;

	protected LoaderEntry data;

	public LoaderBase(RepositoryLanguage repoLanguage, LoaderEntry data) {
		super();
		this.repoLanguage=repoLanguage;
		this.isScanDependent=data.isScanDependent();
		this.data = data;
	}

	protected Integer storeErrorMessage(final int scanId, final int sourceUnitId, final Throwable e) throws SQLException {
		return new Integer(repoLanguage.getFactory().storeErrorMessage(
			scanId, 
			new Integer(sourceUnitId), 
			e));
	}

}
