/*
 * mesopotamia @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package org.mesopotamia;

import java.io.Serializable;

/**
 * Distributable jobs shall implement this interface.
 * Remote repository factories will inject themselves
 * into jobs. Job will lookup factory components needed to
 * perform job's operations.
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public interface MesopotamiaJob extends Runnable, Serializable {
	
	/**
	 * Factory injector.
	 * @param factory
	 */
	void setFactory(RepositoryFactory factory);
}
