package org.mesopotamia;

import java.util.ArrayList;
import java.util.List;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;

/**
 * This class represents "raw" syntax tree node.
 * @author Pavel Vlasov
 */
public class MesopotamiaNode extends NodeData {
	
	private String typeName;
	
	public MesopotamiaNode(String typeName, MesopotamiaNode parent) {
		this.parent = parent;
		this.typeName = typeName;
	}
	
	private MesopotamiaNode parent;
	private List<MesopotamiaNode> children = new ArrayList<MesopotamiaNode>();
	
	public List<MesopotamiaNode> getChildren() {
		return children;
	}
	
	public void setChildren(List<MesopotamiaNode> children) {
		this.children = children;
	}
	
	public MesopotamiaNode getParent() {
		return parent;
	}
	
	@Override
	public Object clone() throws CloneNotSupportedException {
		MesopotamiaNode ret = (MesopotamiaNode) super.clone();
		ret.typeName = getTypeName();
		return ret;
	}
	
	protected void acceptChildren(Visitor visitor) {
		new CollectionVisitable(children, false).accept(visitor);
	}
	
	public String getTypeName() {
		return typeName;
	}
	
	public String toString() {
		return getTypeName()+" "+getText();
	}
	
}
