/*
 * mesopotamia @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package org.mesopotamia;

import java.util.List;

import org.w3c.dom.Element;

import biz.hammurapi.convert.ConvertingService;
import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;
import biz.hammurapi.xml.dom.DomSerializable;


public class SimpleLanguageElement extends LanguageElement {

	public SimpleLanguageElement(
			NodeData xData,
			Class context,
			Scan scan,
			RepositoryLanguage language,
			Object environment) {
		super(xData, context, scan, language, environment);
	}

	protected void acceptChildren(Visitor visitor) {
		try {
			new CollectionVisitable(getChildren(), false).accept(visitor);
		} catch (MesopotamiaException e) {
			throw new MesopotamiaRuntimeException(e);
		}
	}
	
	
	public void toDom(Element holder) {
		super.toDom(holder);
		Element le=holder.getOwnerDocument().createElement("children");
		holder.appendChild(le);
		try {
			DomSerializable ds = (DomSerializable) ConvertingService.convert(getChildren(), DomSerializable.class); 
			ds.toDom(le);
		} catch (MesopotamiaException e) {
			throw new MesopotamiaRuntimeException(e);
		}
	}
	
	public List<Object> getChildren() throws MesopotamiaException {
		return super.getChildren();
	}
}
