/*
 * mesopotamia @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package org.mesopotamia;

/**
 * Listens for loading source units at particular level.
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public interface SourceUnitLoadListener {
	
	/**
	 * Invoked when source unit is loaded to particular level
	 * @param scanId
	 * @param sourceUnitId
	 * @param level
	 */
	void onLoad(int scanId, int sourceUnitId, String level);
	
	/**
	 * Invoked when source unit is linked to scan on particular level.
	 * @param scanId
	 * @param sourceUnitId
	 * @param level
	 */
	void onLink(int scanId, int sourceUnitId, String level);
	
}
