/*
 *  * mesopotamia @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package org.mesopotamia.util;

import gnu.trove.TIntHashSet;

import java.io.Reader;
import java.io.StringReader;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import javax.swing.JFrame;

import antlr.ASTFactory;
import antlr.Parser;
import antlr.Token;
import antlr.TokenStream;
import antlr.TokenStreamException;
import antlr.collections.AST;
import biz.hammurapi.antlr.ASTFrame.JTreeASTModel;


/**
 * @author Pavel Vlasov
 * 
 */
public class AstDebugger extends JFrame {

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JLabel jLabel = null;

	private javax.swing.JTextField lexerField = null;

	private javax.swing.JTree jTree = null;

	private javax.swing.JLabel jLabel1 = null;

	private javax.swing.JTextField parserField = null;

	private javax.swing.JLabel jLabel2 = null;

	private javax.swing.JTextPane jTextPane = null;

	private javax.swing.JLabel statusLabel = null; // @jve:visual-info
													// decl-index=0
													// visual-constraint="415,698"

	private javax.swing.JComboBox methodComboBox = null;

	private javax.swing.JSplitPane jSplitPane = null;

	private javax.swing.JPanel jPanel1 = null;

	private javax.swing.JScrollPane jScrollPane = null;

	private javax.swing.JLabel jLabel3 = null;

	private javax.swing.JTextField wsTokensField = null;

	/**
	 * This is the default constructor
	 */
	public AstDebugger() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setContentPane(getJContentPane());
		this.setSize(841, 709);
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setTitle("AST Debugger");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			java.awt.GridBagConstraints consGridBagConstraints12 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints31 = new java.awt.GridBagConstraints();
			consGridBagConstraints12.gridx = 0;
			consGridBagConstraints12.gridy = 4;
			consGridBagConstraints12.gridwidth = 5;
			consGridBagConstraints31.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints31.weighty = 1.0;
			consGridBagConstraints31.weightx = 1.0;
			consGridBagConstraints31.gridy = 3;
			consGridBagConstraints31.gridx = 2;
			consGridBagConstraints31.gridwidth = 3;
			jContentPane.setLayout(new java.awt.GridBagLayout());
			jContentPane.add(getJSplitPane(), consGridBagConstraints31);
			jContentPane.add(getStatusLabel(), consGridBagConstraints12);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText("Lexer ");
		}
		return jLabel;
	}

	/**
	 * This method initializes wsTokensField
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getLexerField() {
		if (lexerField == null) {
			lexerField = new javax.swing.JTextField();
			lexerField.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					lastUpdate = System.currentTimeMillis();
				}
			});
		}
		return lexerField;
	}

	/**
	 * This method initializes jTree
	 * 
	 * @return javax.swing.JTree
	 */
	private javax.swing.JTree getJTree() {
		if (jTree == null) {
			jTree = new javax.swing.JTree();
		}
		return jTree;
	}

	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText("WS tokens");
		}
		return jLabel1;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getParserField() {
		if (parserField == null) {
			parserField = new javax.swing.JTextField();
			parserField.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					lastUpdate = System.currentTimeMillis();
					parserClassUpdated = true;
				}
			});
		}
		return parserField;
	}

	/**
	 * This method initializes jLabel2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			jLabel2.setText("Method ");
		}
		return jLabel2;
	}

	/**
	 * This method initializes jTextPane
	 * 
	 * @return javax.swing.JTextPane
	 */
	private javax.swing.JTextPane getJTextPane() {
		if (jTextPane == null) {
			jTextPane = new javax.swing.JTextPane();
			jTextPane.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					lastUpdate = System.currentTimeMillis();
				}
			});
		}
		return jTextPane;
	}

	/**
	 * This method initializes jLabel3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getStatusLabel() {
		if (statusLabel == null) {
			statusLabel = new javax.swing.JLabel();
			statusLabel.setText(" ");
		}
		return statusLabel;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getMethodComboBox() {
		if (methodComboBox == null) {
			methodComboBox = new javax.swing.JComboBox();
			methodComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					lastUpdate = System.currentTimeMillis();
				}
			});
		}
		return methodComboBox;
	}

	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private javax.swing.JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new javax.swing.JSplitPane();
			jSplitPane.setLeftComponent(getJPanel1());
			jSplitPane.setRightComponent(getJPanel());
			jSplitPane.setDividerLocation(400);
		}
		return jSplitPane;
	}

	private static class MethodEntry implements Comparable {
		Method method;

		/**
		 * @param method
		 */
		public MethodEntry(Method method) {
			super();
			// TODO Auto-generated constructor stub
			this.method = method;
		}

		public String toString() {
			return method.getName();
		}

		public int compareTo(Object o) {
			return toString().compareTo(((MethodEntry) o).toString());
		}

	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			java.awt.GridBagConstraints consGridBagConstraints51 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints61 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints8 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints9 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints10 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints11 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints13 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints14 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints71 = new java.awt.GridBagConstraints();
			consGridBagConstraints13.gridy = 2;
			consGridBagConstraints13.gridx = 0;
			consGridBagConstraints14.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints14.weightx = 1.0;
			consGridBagConstraints14.gridy = 3;
			consGridBagConstraints14.gridx = 2;
			consGridBagConstraints51.gridy = 0;
			consGridBagConstraints51.gridx = 0;
			consGridBagConstraints9.gridy = 4;
			consGridBagConstraints9.gridx = 0;
			consGridBagConstraints8.gridy = 3;
			consGridBagConstraints8.gridx = 0;
			consGridBagConstraints61.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints61.weightx = 1.0;
			consGridBagConstraints61.gridy = 0;
			consGridBagConstraints61.gridx = 2;
			consGridBagConstraints10.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints10.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints10.weightx = 1.0;
			consGridBagConstraints10.gridy = 4;
			consGridBagConstraints10.gridx = 2;
			consGridBagConstraints11.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints11.weighty = 1.0;
			consGridBagConstraints11.weightx = 1.0;
			consGridBagConstraints11.gridy = 5;
			consGridBagConstraints11.gridx = 0;
			consGridBagConstraints11.gridwidth = 3;
			consGridBagConstraints61.gridwidth = 2;
			consGridBagConstraints71.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints71.weightx = 1.0;
			consGridBagConstraints71.gridy = 2;
			consGridBagConstraints71.gridx = 2;
			consGridBagConstraints71.gridwidth = 2;
			jPanel1.setLayout(new java.awt.GridBagLayout());
			jPanel1.add(getJLabel(), consGridBagConstraints51);
			jPanel1.add(getLexerField(), consGridBagConstraints61);
			jPanel1.add(getParserField(), consGridBagConstraints71);
			jPanel1.add(getJLabel1(), consGridBagConstraints8);
			jPanel1.add(getJLabel2(), consGridBagConstraints9);
			jPanel1.add(getMethodComboBox(), consGridBagConstraints10);
			jPanel1.add(getJScrollPane(), consGridBagConstraints11);
			jPanel1.add(getJLabel3(), consGridBagConstraints13);
			jPanel1.add(getWsTokensField(), consGridBagConstraints14);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getJTextPane());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jLabel3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel3() {
		if (jLabel3 == null) {
			jLabel3 = new javax.swing.JLabel();
			jLabel3.setText("Parser");
		}
		return jLabel3;
	}

	/**
	 * This method initializes wsTokensField
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getWsTokensField() {
		if (wsTokensField == null) {
			wsTokensField = new javax.swing.JTextField();
			wsTokensField.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					lastUpdate = System.currentTimeMillis();
				}
			});
		}
		return wsTokensField;
	}

	private long lastUpdate;

	private boolean parserClassUpdated;

	private javax.swing.JPanel jPanel = null;
	private javax.swing.JButton jButton = null;
	private javax.swing.JButton jButton1 = null;
	private javax.swing.JButton jButton2 = null;
	{
		Thread performer = new Thread() {
			public void run() {
				while (true) {
					try {
						sleep(100);
					} catch (InterruptedException e1) {
						return;
					}

					if (lastUpdate != 0 && System.currentTimeMillis() - lastUpdate > 2000) {
						lastUpdate = 0;
						process();
					}
				}
			}

			/**
			 * 
			 */
			private void process() {
				getJTree().setModel(null);
				status(" ");
				try {
					String lexerClassName = getLexerField().getText();
					if (lexerClassName == null || lexerClassName.trim().length() == 0) {
						status("Enter lexer class name");
						return;
					}

					Class lexerClass = Class.forName(lexerClassName);
					if (!TokenStream.class.isAssignableFrom(lexerClass)) {
						status(lexerClass.getName() + " does not implement " + TokenStream.class);
						return;
					}

					Constructor lc = lexerClass.getConstructor(new Class[] { Reader.class });

					String parserClassName = getParserField().getText();
					if (parserClassName == null || parserClassName.trim().length() == 0) {
						status("Enter parser class name");
						return;
					}

					Class parserClass = Class.forName(parserClassName);
					if (!Parser.class.isAssignableFrom(parserClass)) {
						status(parserClass.getName() + " does is not a subclass of " + Parser.class);
						return;
					}

					if (parserClassUpdated) {
						parserClassUpdated = false;
						methodComboBox.removeAllItems();
						List<MethodEntry> methods = new ArrayList<MethodEntry>();
						Method[] parserMethods = parserClass.getMethods();
						for (int i = 0; i < parserMethods.length; i++) {
							if (parserMethods[i].getParameterTypes().length == 0) {
								methods.add(new MethodEntry(parserMethods[i]));
							}
						}

						Collections.sort(methods);
						Iterator<MethodEntry> mit = methods.iterator();
						while (mit.hasNext()) {
							methodComboBox.addItem(mit.next());
						}
					}

					if (methodComboBox.getSelectedItem() == null) {
						status("Select parse method");
						return;
					}

					final TIntHashSet wsTokens = new TIntHashSet();
					String[] tokenNames = (String[]) parserClass.getField("_tokenNames").get(null);
					String wsTokensString = getWsTokensField().getText();
					if (wsTokensString.trim().length() > 0) {
						StringTokenizer st = new StringTokenizer(wsTokensString, ", ");
						W: while (st.hasMoreTokens()) {
							String wsToken = st.nextToken().trim();
							for (int i = 0; i < tokenNames.length; i++) {
								if (wsToken.equals(tokenNames[i])) {
									wsTokens.add(i);
									continue W;
								}
							}
							status("Invalid token name: " + wsToken);
							return;
						}
					}

					String text = getJTextPane().getText();
					if (text.length() == 0) {
						status("Type text to parse");
						return;
					}

					final Object lexer = lc.newInstance(new Object[] { new StringReader(text) });
					Constructor pc = parserClass.getConstructor(new Class[] { TokenStream.class });
					Object parser = pc.newInstance(new Object[] { new TokenStream() {

						public Token nextToken() throws TokenStreamException {
							Token ret = ((TokenStream) lexer).nextToken();
							return wsTokens.contains(ret.getType()) ? nextToken() : ret;
						}

					} });

					Method selectedMethod = ((MethodEntry) methodComboBox.getSelectedItem()).method;
					selectedMethod.invoke(parser);
					AST ast = ((Parser) parser).getAST();

					ASTFactory astFactory = new ASTFactory();

					AST r = astFactory.create(0, selectedMethod.getName());
					r.setFirstChild(ast);

					JTreeASTModel model = new JTreeASTModel(r, tokenNames);
					getJTree().setModel(model);
					status(new Date().toString());
				} catch (Exception e) {
					Throwable cause=e;
					while (cause.getCause()!=null && cause.getCause()!=cause) {
						cause=cause.getCause();
					}
					status(cause.toString());
					cause.printStackTrace();
				}
			}
		};

		performer.setName("Parsing thread");
		performer.setDaemon(true);
		performer.start();
	}

	private void status(String status) {
		getStatusLabel().setText(status);
	}

	public static void main(String[] args) {
		AstDebugger astDebugger = new AstDebugger();
		astDebugger.getJTree().setModel(null);
		astDebugger.setVisible(true);
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = new javax.swing.JPanel();
			java.awt.GridBagConstraints consGridBagConstraints3 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints4 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints5 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints6 = new java.awt.GridBagConstraints();
			consGridBagConstraints5.gridy = 1;
			consGridBagConstraints5.gridx = 2;
			consGridBagConstraints6.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints6.weighty = 1.0;
			consGridBagConstraints6.weightx = 1.0;
			consGridBagConstraints6.gridy = 0;
			consGridBagConstraints6.gridx = 0;
			consGridBagConstraints6.gridwidth = 3;
			consGridBagConstraints3.gridy = 1;
			consGridBagConstraints3.gridx = 0;
			consGridBagConstraints4.gridy = 1;
			consGridBagConstraints4.gridx = 1;
			jPanel.setLayout(new java.awt.GridBagLayout());
			jPanel.add(getJButton(), consGridBagConstraints3);
			jPanel.add(getJButton1(), consGridBagConstraints4);
			jPanel.add(getJButton2(), consGridBagConstraints5);
			jPanel.add(getJTree(), consGridBagConstraints6);
		}
		return jPanel;
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton() {
		if(jButton == null) {
			jButton = new javax.swing.JButton();
			jButton.setText("Expand all");
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton1() {
		if(jButton1 == null) {
			jButton1 = new javax.swing.JButton();
			jButton1.setText("Collapse All");
			jButton1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jButton1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return jButton1;
	}
	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButton2() {
		if(jButton2 == null) {
			jButton2 = new javax.swing.JButton();
			jButton2.setText("Print");
			jButton2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jButton2.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					new ComponentPrinter(getJTree()).print();
				}
			});
		}
		return jButton2;
	}
}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10" @jve:visual-info decl-index=0 visual-constraint="4,5"
