/*
 * mesopotamia @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */
package org.mesopotamia.util;

import java.util.AbstractList;
import java.util.List;

import biz.hammurapi.convert.ConverterClosure;

/**
 * Generic duplicate of biz.hammurapi.UnmodifiableConvertingList
 * @author Tatyana Konukova
 *
 */
public class UnmodifiableConvertingList<T> extends AbstractList<T> {
	private List master;
	private ConverterClosure converter;

	public UnmodifiableConvertingList(List master, ConverterClosure converter) {
		super();
		this.master=master;
		this.converter=converter;
	}

	@SuppressWarnings("unchecked")
	public T get(int index) {
		return (T) converter.convert(master.get(index));
	}

	public int size() {
		return master.size();
	}

	/**
	 * @param o
	 * @return master list
	 */
	public List getMaster() {
		return master;
	}
}
